/**
 * http://github.com/Valums-File-Uploader/file-uploader
 *
 * Multiple file upload component with progress-bar, drag-and-drop.
 *
 * Have ideas for improving this JS for the general community?
 * Submit your changes at: https://github.com/Valums-File-Uploader/file-uploader
 *
 * VERSION 2.0 beta
 * Original version 1.0 © 2010 Andrew Valums ( andrew(at)valums.com )
 *
 * Licensed under MIT license, GNU GPL 2 or later, GNU LGPL 2 or later, see license.txt.
 *///
// Helper functions
//
var qq=qq||{};qq.extend=function(e,t){for(var n in t)e[n]=t[n]};qq.indexOf=function(e,t,n){if(e.indexOf)return e.indexOf(t,n);n=n||0;var r=e.length;n<0&&(n+=r);for(;n<r;n++)if(n in e&&e[n]===t)return n;return-1};qq.getUniqueId=function(){var e=0;return function(){return e++}}();qq.ie=function(){return navigator.userAgent.indexOf("MSIE")!=-1};qq.safari=function(){return navigator.vendor!=undefined&&navigator.vendor.indexOf("Apple")!=-1};qq.chrome=function(){return navigator.vendor!=undefined&&navigator.vendor.indexOf("Google")!=-1};qq.firefox=function(){return navigator.userAgent.indexOf("Mozilla")!=-1&&navigator.vendor!=undefined&&navigator.vendor==""};qq.windows=function(){return navigator.platform=="Win32"};qq.attach=function(e,t,n){e.addEventListener?e.addEventListener(t,n,!1):e.attachEvent&&e.attachEvent("on"+t,n);return function(){qq.detach(e,t,n)}};qq.detach=function(e,t,n){e.removeEventListener?e.removeEventListener(t,n,!1):e.attachEvent&&e.detachEvent("on"+t,n)};qq.preventDefault=function(e){e.preventDefault?e.preventDefault():e.returnValue=!1};qq.insertBefore=function(e,t){t.parentNode.insertBefore(e,t)};qq.remove=function(e){e.parentNode.removeChild(e)};qq.contains=function(e,t){return e==t?!0:e.contains?e.contains(t):!!(t.compareDocumentPosition(e)&8)};qq.toElement=function(){var e=document.createElement("div");return function(t){e.innerHTML=t;var n=e.firstChild;e.removeChild(n);return n}}();qq.css=function(e,t){t.opacity!=null&&typeof e.style.opacity!="string"&&typeof e.filters!="undefined"&&(t.filter="alpha(opacity="+Math.round(100*t.opacity)+")");qq.extend(e.style,t)};qq.hasClass=function(e,t){var n=new RegExp("(^| )"+t+"( |$)");return n.test(e.className)};qq.addClass=function(e,t){qq.hasClass(e,t)||(e.className+=" "+t)};qq.removeClass=function(e,t){var n=new RegExp("(^| )"+t+"( |$)");e.className=e.className.replace(n," ").replace(/^\s+|\s+$/g,"")};qq.setText=function(e,t){e.innerText=t;e.textContent=t};qq.children=function(e){var t=[],n=e.firstChild;while(n){n.nodeType==1&&t.push(n);n=n.nextSibling}return t};qq.getByClass=function(e,t){if(e.querySelectorAll)return e.querySelectorAll("."+t);var n=[],r=e.getElementsByTagName("*"),i=r.length;for(var s=0;s<i;s++)qq.hasClass(r[s],t)&&n.push(r[s]);return n};qq.obj2url=function(e,t,n){var r=[],i="&",s=function(e,n){var i=t?/\[\]$/.test(t)?t:t+"["+n+"]":n;i!="undefined"&&n!="undefined"&&r.push(typeof e=="object"?qq.obj2url(e,i,!0):Object.prototype.toString.call(e)==="[object Function]"?encodeURIComponent(i)+"="+encodeURIComponent(e()):encodeURIComponent(i)+"="+encodeURIComponent(e))};if(!n&&t){i=/\?/.test(t)?/\?$/.test(t)?"":"&":"?";r.push(t);r.push(qq.obj2url(e))}else if(Object.prototype.toString.call(e)==="[object Array]"&&typeof e!="undefined")for(var o=0,u=e.length;o<u;++o)s(e[o],o);else if(typeof e!="undefined"&&e!==null&&typeof e=="object")for(var o in e)s(e[o],o);else r.push(encodeURIComponent(t)+"="+encodeURIComponent(e));return r.join(i).replace(/^&/,"").replace(/%20/g,"+")};var qq=qq||{};qq.FileUploaderBasic=function(e){this._options={debug:!1,action:"/server/upload",params:{},customHeaders:{},button:null,multiple:!0,maxConnections:3,allowedExtensions:[],acceptFiles:null,sizeLimit:0,minSizeLimit:0,onSubmit:function(e,t){},onProgress:function(e,t,n,r){},onComplete:function(e,t,n){},onCancel:function(e,t){},onUpload:function(e,t,n){},onError:function(e,t,n){},messages:{typeError:"Unfortunately the file(s) you selected weren't the type we were expecting. Only {extensions} files are allowed.",sizeError:"{file} is too large, maximum file size is {sizeLimit}.",minSizeError:"{file} is too small, minimum file size is {minSizeLimit}.",emptyError:"{file} is empty, please select files again without it.",onLeave:"The files are being uploaded, if you leave now the upload will be cancelled."},showMessage:function(e){alert(e)},inputName:"photo",extraDropzones:[]};qq.extend(this._options,e);qq.extend(this,qq.DisposeSupport);this._filesInProgress=0;this._handler=this._createUploadHandler();this._options.button&&(this._button=this._createUploadButton(this._options.button));this._preventLeaveInProgress()};qq.FileUploaderBasic.prototype={setParams:function(e){this._options.params=e},getInProgress:function(){return this._filesInProgress},_createUploadButton:function(e){var t=this,n=new qq.UploadButton({element:e,multiple:this._options.multiple&&qq.UploadHandlerXhr.isSupported(),acceptFiles:this._options.acceptFiles,onChange:function(e){t._onInputChange(e)}});this.addDisposer(function(){n.dispose()});return n},_createUploadHandler:function(){var e=this,t;qq.UploadHandlerXhr.isSupported()?t="UploadHandlerXhr":t="UploadHandlerForm";var n=new qq[t]({debug:this._options.debug,action:this._options.action,encoding:this._options.encoding,maxConnections:this._options.maxConnections,customHeaders:this._options.customHeaders,inputName:this._options.inputName,extraDropzones:this._options.extraDropzones,onProgress:function(t,n,r,i){e._onProgress(t,n,r,i);e._options.onProgress(t,n,r,i)},onComplete:function(t,n,r){e._onComplete(t,n,r);e._options.onComplete(t,n,r)},onCancel:function(t,n){e._onCancel(t,n);e._options.onCancel(t,n)},onError:e._options.onError,onUpload:function(t,n,r){e._onUpload(t,n,r);e._options.onUpload(t,n,r)}});return n},_preventLeaveInProgress:function(){var e=this;this._attach(window,"beforeunload",function(t){if(!e._filesInProgress)return;var t=t||window.event;t.returnValue=e._options.messages.onLeave;return e._options.messages.onLeave})},_onSubmit:function(e,t){this._filesInProgress++},_onProgress:function(e,t,n,r){},_onComplete:function(e,t,n){this._filesInProgress--;n.error&&this._options.showMessage(n.error)},_onCancel:function(e,t){this._filesInProgress--},_onUpload:function(e,t,n){},_onInputChange:function(e){this._handler instanceof qq.UploadHandlerXhr?this._uploadFileList(e.files):this._validateFile(e)&&this._uploadFile(e);this._button.reset()},_uploadFileList:function(e){for(var t=0;t<e.length;t++)if(!this._validateFile(e[t]))return;for(var t=0;t<e.length;t++)this._uploadFile(e[t])},_uploadFile:function(e){var t=this._handler.add(e),n=this._handler.getName(t);if(this._options.onSubmit(t,n)!==!1){this._onSubmit(t,n);this._handler.upload(t,this._options.params)}},_validateFile:function(e){var t,n;if(e.value)t=e.value.replace(/.*(\/|\\)/,"");else{t=e.fileName!==null&&e.fileName!==undefined?e.fileName:e.name;n=e.fileSize!==null&&e.fileSize!==undefined?e.fileSize:e.size}if(!this._isAllowedExtension(t)){this._error("typeError",t);return!1}if(n===0){this._error("emptyError",t);return!1}if(n&&this._options.sizeLimit&&n>this._options.sizeLimit){this._error("sizeError",t);return!1}if(n&&n<this._options.minSizeLimit){this._error("minSizeError",t);return!1}return!0},_error:function(e,t){function r(e,t){n=n.replace(e,t)}var n=this._options.messages[e];r("{file}",this._formatFileName(t));r("{extensions}",this._options.allowedExtensions.join(", "));r("{sizeLimit}",this._formatSize(this._options.sizeLimit));r("{minSizeLimit}",this._formatSize(this._options.minSizeLimit));this._options.showMessage(n)},_formatFileName:function(e){e.length>33&&(e=e.slice(0,19)+"..."+e.slice(-13));return e},_isAllowedExtension:function(e){var t=-1!==e.indexOf(".")?e.replace(/.*[.]/,"").toLowerCase():"",n=this._options.allowedExtensions;if(!n.length)return!0;for(var r=0;r<n.length;r++)if(n[r].toLowerCase()==t)return!0;return!1},_formatSize:function(e){var t=-1;do{e/=1024;t++}while(e>99);return Math.max(e,.1).toFixed(1)+["kB","MB","GB","TB","PB","EB"][t]}};qq.FileUploader=function(e){qq.FileUploaderBasic.apply(this,arguments);qq.extend(this._options,{element:null,listElement:null,dragText:"Drop files here to upload",uploadButtonText:"Upload a file",cancelButtonText:"Cancel",failUploadText:"Upload failed",template:'<div class="qq-uploader"><div class="qq-upload-drop-area"><span>{dragText}</span></div><div class="qq-upload-button">{uploadButtonText}</div><ul class="qq-upload-list"></ul></div>',fileTemplate:'<li><span class="qq-progress-bar"></span><span class="qq-upload-file"></span><span class="qq-upload-spinner"></span><span class="qq-upload-size"></span><a class="qq-upload-cancel" href="#">{cancelButtonText}</a><span class="qq-upload-failed-text">{failUploadtext}</span></li>',classes:{button:"qq-upload-button",drop:"qq-upload-drop-area",dropActive:"qq-upload-drop-area-active",dropDisabled:"qq-upload-drop-area-disabled",list:"qq-upload-list",progressBar:"qq-progress-bar",file:"qq-upload-file",spinner:"qq-upload-spinner",size:"qq-upload-size",cancel:"qq-upload-cancel",success:"qq-upload-success",fail:"qq-upload-fail"}});qq.extend(this._options,e);this._options.template=this._options.template.replace(/\{dragText\}/g,this._options.dragText);this._options.template=this._options.template.replace(/\{uploadButtonText\}/g,this._options.uploadButtonText);this._options.fileTemplate=this._options.fileTemplate.replace(/\{cancelButtonText\}/g,this._options.cancelButtonText);this._options.fileTemplate=this._options.fileTemplate.replace(/\{failUploadtext\}/g,this._options.failUploadText);this._element=this._options.element;this._element.innerHTML=this._options.template;this._listElement=this._options.listElement||this._find(this._element,"list");this._classes=this._options.classes;this._button=this._createUploadButton(this._find(this._element,"button"));this._bindCancelEvent();this._setupDragDrop()};qq.extend(qq.FileUploader.prototype,qq.FileUploaderBasic.prototype);qq.extend(qq.FileUploader.prototype,{addExtraDropzone:function(e){this._setupExtraDropzone(e)},removeExtraDropzone:function(e){var t=this._options.extraDropzones;for(var n in t)if(t[n]===e)return this._options.extraDropzones.splice(n,1)},_leaving_document_out:function(e){return(qq.chrome()||qq.safari()&&qq.windows())&&e.clientX==0&&e.clientY==0||qq.firefox()&&!e.relatedTarget},_find:function(e,t){var n=qq.getByClass(e,this._options.classes[t])[0];if(!n)throw new Error("element not found "+t);return n},_setupExtraDropzone:function(e){this._options.extraDropzones.push(e);this._setupDropzone(e)},_setupDropzone:function(e){var t=this,n=new qq.UploadDropZone({element:e,onEnter:function(n){qq.addClass(e,t._classes.dropActive);n.stopPropagation()},onLeave:function(e){},onLeaveNotDescendants:function(n){qq.removeClass(e,t._classes.dropActive)},onDrop:function(n){e.style.display="none";qq.removeClass(e,t._classes.dropActive);t._uploadFileList(n.dataTransfer.files)}});this.addDisposer(function(){n.dispose()});e.style.display="none"},_setupDragDrop:function(){var e=this._find(this._element,"drop"),t=this;this._options.extraDropzones.push(e);var n=this._options.extraDropzones,r;for(r=0;r<n.length;r++)this._setupDropzone(n[r]);qq.ie()||this._attach(document,"dragenter",function(s){if(qq.hasClass(e,t._classes.dropDisabled))return;e.style.display="block";for(r=0;r<n.length;r++)n[r].style.display="block"});this._attach(document,"dragleave",function(e){var t=document.elementFromPoint(e.clientX,e.clientY);if(qq.FileUploader.prototype._leaving_document_out(e))for(r=0;r<n.length;r++)n[r].style.display="none"});qq.attach(document,"drop",function(e){for(r=0;r<n.length;r++)n[r].style.display="none";e.preventDefault()})},_onSubmit:function(e,t){qq.FileUploaderBasic.prototype._onSubmit.apply(this,arguments);this._addToList(e,t)},_onProgress:function(e,t,n,r){qq.FileUploaderBasic.prototype._onProgress.apply(this,arguments);var i=this._getItemByFileId(e),s=this._find(i,"size");s.style.display="inline";var o,u=Math.round(n/r*100);n!=r?o=u+"% from "+this._formatSize(r):o=this._formatSize(r);this._find(i,"progressBar").style.width=u+"%";qq.setText(s,o)},_onComplete:function(e,t,n){qq.FileUploaderBasic.prototype._onComplete.apply(this,arguments);var r=this._getItemByFileId(e);qq.remove(this._find(r,"cancel"));qq.remove(this._find(r,"spinner"));n.success?qq.addClass(r,this._classes.success):qq.addClass(r,this._classes.fail)},_addToList:function(e,t){var n=qq.toElement(this._options.fileTemplate);n.qqFileId=e;var r=this._find(n,"file");qq.setText(r,this._formatFileName(t));this._find(n,"size").style.display="none";this._options.multiple||this._clearList();this._listElement.appendChild(n)},_clearList:function(){this._listElement.innerHTML=""},_getItemByFileId:function(e){var t=this._listElement.firstChild;while(t){if(t.qqFileId==e)return t;t=t.nextSibling}},_bindCancelEvent:function(){var e=this,t=this._listElement;this._attach(t,"click",function(t){t=t||window.event;var n=t.target||t.srcElement;if(qq.hasClass(n,e._classes.cancel)){qq.preventDefault(t);var r=n.parentNode;e._handler.cancel(r.qqFileId);qq.remove(r)}})}});qq.UploadDropZone=function(e){this._options={element:null,onEnter:function(e){},onLeave:function(e){},onLeaveNotDescendants:function(e){},onDrop:function(e){}};qq.extend(this._options,e);qq.extend(this,qq.DisposeSupport);this._element=this._options.element;this._disableDropOutside();this._attachEvents()};qq.UploadDropZone.prototype={_dragover_should_be_canceled:function(){return qq.safari()||qq.firefox()&&qq.windows()},_disableDropOutside:function(e){if(!qq.UploadDropZone.dropOutsideDisabled){this._dragover_should_be_canceled?qq.attach(document,"dragover",function(e){e.preventDefault()}):qq.attach(document,"dragover",function(e){if(e.dataTransfer){e.dataTransfer.dropEffect="none";e.preventDefault()}});qq.UploadDropZone.dropOutsideDisabled=!0}},_attachEvents:function(){var e=this;e._attach(e._element,"dragover",function(t){if(!e._isValidFileDrag(t))return;var n=qq.ie()?null:t.dataTransfer.effectAllowed;n=="move"||n=="linkMove"?t.dataTransfer.dropEffect="move":t.dataTransfer.dropEffect="copy";t.stopPropagation();t.preventDefault()});e._attach(e._element,"dragenter",function(t){if(!e._isValidFileDrag(t))return;e._options.onEnter(t)});e._attach(e._element,"dragleave",function(t){if(!e._isValidFileDrag(t))return;e._options.onLeave(t);var n=document.elementFromPoint(t.clientX,t.clientY);if(qq.contains(this,n))return;e._options.onLeaveNotDescendants(t)});e._attach(e._element,"drop",function(t){if(!e._isValidFileDrag(t))return;t.preventDefault();e._options.onDrop(t)})},_isValidFileDrag:function(e){if(qq.ie())return!1;var t=e.dataTransfer,n=qq.safari();return t&&t.effectAllowed!="none"&&(t.files||!n&&t.types.contains&&t.types.contains("Files"))}};qq.UploadButton=function(e){this._options={element:null,multiple:!1,acceptFiles:null,name:"file",onChange:function(e){},hoverClass:"qq-upload-button-hover",focusClass:"qq-upload-button-focus"};qq.extend(this._options,e);qq.extend(this,qq.DisposeSupport);this._element=this._options.element;qq.css(this._element,{position:"relative",overflow:"hidden",direction:"ltr"});this._input=this._createInput()};qq.UploadButton.prototype={getInput:function(){return this._input},reset:function(){this._input.parentNode&&qq.remove(this._input);qq.removeClass(this._element,this._options.focusClass);this._input=this._createInput()},_createInput:function(){var e=document.createElement("input");this._options.multiple&&e.setAttribute("multiple","multiple");this._options.acceptFiles&&e.setAttribute("accept",this._options.acceptFiles);e.setAttribute("type","file");e.setAttribute("name",this._options.name);qq.css(e,{position:"absolute",right:0,top:0,fontFamily:"Arial",fontSize:"118px",margin:0,padding:0,cursor:"pointer",opacity:0});this._element.appendChild(e);var t=this;this._attach(e,"change",function(){t._options.onChange(e)});this._attach(e,"mouseover",function(){qq.addClass(t._element,t._options.hoverClass)});this._attach(e,"mouseout",function(){qq.removeClass(t._element,t._options.hoverClass)});this._attach(e,"focus",function(){qq.addClass(t._element,t._options.focusClass)});this._attach(e,"blur",function(){qq.removeClass(t._element,t._options.focusClass)});window.attachEvent&&e.setAttribute("tabIndex","-1");return e}};qq.UploadHandlerAbstract=function(e){this._options={debug:!1,action:"/upload.php",maxConnections:999,onProgress:function(e,t,n,r){},onComplete:function(e,t,n){},onCancel:function(e,t){},onUpload:function(e,t,n){}};qq.extend(this._options,e);this._queue=[];this._params=[]};qq.UploadHandlerAbstract.prototype={log:function(e){this._options.debug&&window.console&&console.log("[uploader] "+e)},add:function(e){},upload:function(e,t){var n=this._queue.push(e),r={};qq.extend(r,t);this._params[e]=r;n<=this._options.maxConnections&&this._upload(e,this._params[e])},cancel:function(e){this._cancel(e);this._dequeue(e)},cancelAll:function(){for(var e=0;e<this._queue.length;e++)this._cancel(this._queue[e]);this._queue=[]},getName:function(e){},getSize:function(e){},getQueue:function(){return this._queue},_upload:function(e){},_cancel:function(e){},_dequeue:function(e){var t=qq.indexOf(this._queue,e);this._queue.splice(t,1);var n=this._options.maxConnections;if(this._queue.length>=n&&t<n){var r=this._queue[n-1];this._upload(r,this._params[r])}}};qq.UploadHandlerForm=function(e){qq.UploadHandlerAbstract.apply(this,arguments);this._inputs={}};qq.extend(qq.UploadHandlerForm.prototype,qq.UploadHandlerAbstract.prototype);qq.extend(qq.UploadHandlerForm.prototype,{add:function(e){e.setAttribute("name",this._options.inputName);var t="qq-upload-handler-iframe"+qq.getUniqueId();this._inputs[t]=e;e.parentNode&&qq.remove(e);return t},getName:function(e){return this._inputs[e].value.replace(/.*(\/|\\)/,"")},_cancel:function(e){this._options.onCancel(e,this.getName(e));delete this._inputs[e];var t=document.getElementById(e);if(t){t.setAttribute("src","javascript:false;");qq.remove(t)}},_upload:function(e,t){this._options.onUpload(e,this.getName(e),!1);var n=this._inputs[e];if(!n)throw new Error("file with passed id was not added, or already uploaded or cancelled");var r=this.getName(e),i=this._createIframe(e),s=this._createForm(i,t);s.appendChild(n);var o=this;this._attachLoadEvent(i,function(){o.log("iframe loaded");var t=o._getIframeContentJSON(i);o._options.onComplete(e,r,t);o._dequeue(e);delete o._inputs[e];setTimeout(function(){o._detach_event();qq.remove(i)},1)});s.submit();qq.remove(s);return e},_attachLoadEvent:function(e,t){this._detach_event=qq.attach(e,"load",function(){if(!e.parentNode)return;if(e.contentDocument&&e.contentDocument.body&&e.contentDocument.body.innerHTML=="false")return;t()})},_getIframeContentJSON:function(iframe){var doc=iframe.contentDocument?iframe.contentDocument:iframe.contentWindow.document,response,innerHTML=doc.body.innerHTML;this.log("converting iframe's innerHTML to JSON");this.log("innerHTML = "+innerHTML);innerHTML.slice(0,5).toLowerCase()=="<pre>"&&innerHTML.slice(-6).toLowerCase()=="</pre>"&&(innerHTML=doc.body.firstChild.firstChild.nodeValue);try{response=eval("("+innerHTML+")")}catch(err){response={}}return response},_createIframe:function(e){var t=qq.toElement('<iframe src="javascript:false;" name="'+e+'" />');t.setAttribute("id",e);t.style.display="none";document.body.appendChild(t);return t},_createForm:function(e,t){var n=qq.toElement('<form method="post" enctype="multipart/form-data"></form>'),r=qq.obj2url(t,this._options.action);n.setAttribute("action",r);n.setAttribute("target",e.name);n.style.display="none";document.body.appendChild(n);return n}});qq.UploadHandlerXhr=function(e){qq.UploadHandlerAbstract.apply(this,arguments);this._files=[];this._xhrs=[];this._loaded=[]};qq.UploadHandlerXhr.isSupported=function(){var e=document.createElement("input");e.type="file";return"multiple"in e&&typeof File!="undefined"&&typeof FormData!="undefined"&&typeof (new XMLHttpRequest).upload!="undefined"};qq.extend(qq.UploadHandlerXhr.prototype,qq.UploadHandlerAbstract.prototype);qq.extend(qq.UploadHandlerXhr.prototype,{add:function(e){if(e instanceof File)return this._files.push(e)-1;throw new Error("Passed obj in not a File (in qq.UploadHandlerXhr)")},getName:function(e){var t=this._files[e];return t.fileName!==null&&t.fileName!==undefined?t.fileName:t.name},getSize:function(e){var t=this._files[e];return t.fileSize!=null?t.fileSize:t.size},getLoaded:function(e){return this._loaded[e]||0},_upload:function(e,t){this._options.onUpload(e,this.getName(e),!0);var n=this._files[e],r=this.getName(e),i=this.getSize(e);this._loaded[e]=0;var s=this._xhrs[e]=new XMLHttpRequest,o=this;s.upload.onprogress=function(t){if(t.lengthComputable){o._loaded[e]=t.loaded;o._options.onProgress(e,r,t.loaded,t.total)}};s.onreadystatechange=function(){s.readyState==4&&o._onComplete(e,s)};t=t||{};t[this._options.inputName]=r;var u=qq.obj2url(t,this._options.action);s.open("POST",u,!0);s.setRequestHeader("X-Requested-With","XMLHttpRequest");s.setRequestHeader("X-File-Name",encodeURIComponent(r));if(this._options.encoding=="multipart"){var a=new FormData;a.append(r,n);n=a}else{s.setRequestHeader("Content-Type","application/octet-stream");s.setRequestHeader("X-Mime-Type",n.type)}for(key in this._options.customHeaders)s.setRequestHeader(key,this._options.customHeaders[key]);s.send(n)},_onComplete:function(id,xhr){if(!this._files[id])return;var name=this.getName(id),size=this.getSize(id);this._options.onProgress(id,name,size,size);if(xhr.status==200){this.log("xhr - server response received");this.log("responseText = "+xhr.responseText);var response;try{response=eval("("+xhr.responseText+")")}catch(err){response={}}this._options.onComplete(id,name,response)}else{this._options.onError(id,name,xhr);this._options.onComplete(id,name,{})}this._files[id]=null;this._xhrs[id]=null;this._dequeue(id)},_cancel:function(e){this._options.onCancel(e,this.getName(e));this._files[e]=null;if(this._xhrs[e]){this._xhrs[e].abort();this._xhrs[e]=null}}});qq.DisposeSupport={_disposers:[],dispose:function(){var e;while(e=this._disposers.shift())e()},addDisposer:function(e){this._disposers.push(e)},_attach:function(){this.addDisposer(qq.attach.apply(this,arguments))}};